import sys
import math
import dumpParser


class POVRAYGenerator:
    out = None
    
    def __init__(self,output):
        self.out = file(output,"w")
        
    def initialCode(self):
        self.out.write("""  
        #include \"colors.inc\"    // The include files contain
        #include \"stones.inc\"    // pre-defined scene elements
        #include \"textures.inc\"    // pre-defined scene elements
        #include \"shapes.inc\"
        #include \"glass.inc\"
        #include \"metals.inc\"
        #include \"woods.inc\"


        camera {
            location <0, 2, -3>
            look_at  <0, 1,  2>
            }


        """)


    def nodeOut(self,id):
        nodeLine = "sphere {\n"+\
            "  <"+`id[0]`+","+`id[1]`+","+`id[2]`+">, 0.4 \n"+\
    """  texture {
            pigment { color Yellow }
            finish { phong 1 }
            }
       }
    """
        self.out.write(nodeLine)

    def edgeOut(self,src,trg):
        nodeLine = "cylinder {<"+`src[0]`+","+`src[1]`+","+`src[2]`+">,<"+`trg[0]`+","+`trg[1]`+","+`trg[2]`+">,0.05 "+\
              """   texture{
                      pigment{
                        color White
                        }
                      }
                    }\n
                   """
              
        self.out.write(nodeLine)

        
    def terminalCode(self):
        self.out.write("light_source { <2, 4, -3> color White}\n")

generators = []
generators.append(POVRAYGenerator(sys.argv[2]))

dp = dumpParser.DumpParser(generators)
input = file(sys.argv[1])

dp.parse(input)


