import re

def parseIdentifier(idStr):
    idxes = re.split(',',idStr)
    ret = []
    for s in idxes:
        ret.append(eval(s))
    return ret


class DumpParser:
    handler = None
    min = []
    max = []

       
    
    def __init__(self,handler):
        self.handler = handler

        return


    def parse(self,input):
        for h in self.handler:
            h.initialCode()
        

        stateIdRegexpString = "\[([\d,]*)\]"

        edgeRegexp = re.compile("edge:"+stateIdRegexpString+"->"+stateIdRegexpString);
        nodeRegexp = re.compile("node:"+stateIdRegexpString);

        for line in input:
            result = nodeRegexp.match(line)
            if result!=None:
                id = parseIdentifier(result.group(1))
                for h in self.handler:
                    h.nodeOut(id)
                
                continue

            result = edgeRegexp.match(line)
            if result!=None:

                srcId = parseIdentifier(result.group(1))
                trgId = parseIdentifier(result.group(2))
                for h in self.handler:
                    h.edgeOut(srcId,trgId)
                continue

        for h in self.handler:
            h.terminalCode()
        
        return
    
